Index: /trunk/LMDZ.MARS/libf/phymars/inifis.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/inifis.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/inifis.F	(revision 1036)
@@ -1,4 +1,4 @@
       SUBROUTINE inifis(
-     $           ngrid,nlayer
+     $           ngrid,nlayer,nq
      $           ,day_ini,pdaysec,ptimestep
      $           ,plat,plon,parea
@@ -46,5 +46,7 @@
 !   -------------
 ! to use  'getin'
-      USE ioipsl_getincom 
+      USE ioipsl_getincom, only : getin
+      use tracer_mod, only : nqmx, nuice_sed, ccn_factor
+      
       IMPLICIT NONE
 #include "dimensions.h"
@@ -62,16 +64,16 @@
 #include "slope.h"
 #include "microphys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #ifdef MESOSCALE
 #include "comsoil.h"     !!MESOSCALE -- needed to fill volcapa
 #include "meso_inc/meso_inc_inifisvar.F"
 #endif
-      REAL prad,pg,pr,pcpp,pdaysec
-
-      REAL ptimestep 
-      INTEGER day_ini
-
-      INTEGER ngrid,nlayer
-      REAL plat(ngrid),plon(ngrid),parea(ngridmx)
+      REAL,INTENT(IN) :: prad,pg,pr,pcpp,pdaysec
+
+      REAL,INTENT(IN) :: ptimestep 
+      INTEGER,INTENT(IN) :: day_ini
+
+      INTEGER,INTENT(IN) :: ngrid,nlayer,nq
+      REAL,INTENT(IN) :: plat(ngrid),plon(ngrid),parea(ngrid)
       INTEGER ig,ierr
  
@@ -95,4 +97,7 @@
       daysec=pdaysec
       dtphys=ptimestep
+
+      nqmx=nq
+
 #ifdef MESOSCALE
 #include "meso_inc/meso_inc_inifisini.F"
@@ -375,5 +380,5 @@
            stop
          endif
-         if (doubleq.and.submicron.and.(nqmx.LT.3)) then
+         if (doubleq.and.submicron.and.(nq.LT.3)) then
            print*,'If doubleq is used with a submicron tracer,'
            print*,' then the number of tracers has to be'
@@ -804,5 +809,5 @@
 !         print*,' 1 water vapour tracer'
 !         print*,' 1 water ice tracer'
-!         print*,nqmx-4,' chemistry tracers'
+!         print*,nq-4,' chemistry tracers'
 !       endif
 !
@@ -812,6 +817,6 @@
 !         print*,' 1 water vapour tracer'
 !         print*,' 1 water ice tracer'
-!         if (nqmx.LT.4) then
-!           print*,'nqmx should be at least equal to'
+!         if (nq.LT.4) then
+!           print*,'nq should be at least equal to'
 !           print*,'4 with these options.'
 !           stop
@@ -824,5 +829,5 @@
 !           print*,dustbin,' dust bins'
 !         endif
-!         print*,nqmx-2-dustbin,' chemistry tracers'
+!         print*,nq-2-dustbin,' chemistry tracers'
 !         print*,' 1 water vapour tracer'
 !         print*,' 1 water ice tracer'
@@ -836,11 +841,11 @@
 !         print*,' 1 water vapour tracer'
 !         print*,' 1 water ice tracer'
-!         if (nqmx.gt.(dustbin+2)) then
-!           print*,'nqmx should be ',(dustbin+2),
+!         if (nq.gt.(dustbin+2)) then
+!           print*,'nq should be ',(dustbin+2),
 !     $            ' with these options...'
 !		   print*,'(or check callphys.def)'
 !         endif
-!         if (nqmx.lt.(dustbin+2)) then
-!           write(*,*) "inifis: nqmx.lt.(dustbin+2)"
+!         if (nq.lt.(dustbin+2)) then
+!           write(*,*) "inifis: nq.lt.(dustbin+2)"
 !           stop
 !         endif
Index: /trunk/LMDZ.MARS/libf/phymars/initracer.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 1036)
@@ -1,4 +1,6 @@
-      SUBROUTINE initracer(qsurf,co2ice)
-
+      SUBROUTINE initracer(ngrid,nq,qsurf,co2ice)
+
+       use infotrac, only: tnom
+       use tracer_mod
        IMPLICIT NONE
 c=======================================================================
@@ -11,6 +13,6 @@
 c
 c   Test of dimension :
-c   Initialize COMMON tracer in tracer.h, using tracer names provided
-c   by the dynamics in "advtrac.h"
+c   Initialize tracer related data in tracer_mod, using tracer names provided
+c   by the dynamics in "infotrac"
 c
 c
@@ -26,12 +28,15 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
-#include "advtrac.h"
+!#include "tracer.h"
+!#include "advtrac.h"
 #include "comgeomfi.h"
 
 #include "surfdat.h"
 
-      real qsurf(ngridmx,nqmx)       ! tracer on surface (e.g.  kg.m-2)
-      real co2ice(ngridmx)           ! co2 ice mass on surface (e.g.  kg.m-2)
+      integer,intent(in) :: ngrid ! number of atmospheric columns
+      integer,intent(in) :: nq ! number of tracers
+      real,intent(out) :: qsurf(ngrid,nq) ! tracer on surface (e.g.  kg.m-2)
+      real,intent(out) :: co2ice(ngrid) ! co2 ice mass on surface (e.g.  kg.m-2)
+
       integer iq,ig,count
       real r0_lift , reff_lift, nueff_lift
@@ -43,8 +48,8 @@
 
 c-----------------------------------------------------------------------
-c  radius(nqmx)      ! aerosol particle radius (m)
-c  rho_q(nqmx)       ! tracer densities (kg.m-3)
-c  alpha_lift(nqmx)  ! saltation vertical flux/horiz flux ratio (m-1)
-c  alpha_devil(nqmx) ! lifting coeeficient by dust devil
+c  radius(nq)      ! aerosol particle radius (m)
+c  rho_q(nq)       ! tracer densities (kg.m-3)
+c  alpha_lift(nq)  ! saltation vertical flux/horiz flux ratio (m-1)
+c  alpha_devil(nq) ! lifting coeeficient by dust devil
 c  rho_dust          ! Mars dust density
 c  rho_ice           ! Water ice density
@@ -55,4 +60,14 @@
 c-----------------------------------------------------------------------
 
+! Initialization: allocate arrays in tracer_mod
+      allocate(noms(nq))
+      allocate(mmol(nq))
+      allocate(radius(nq))
+      allocate(rho_q(nq))
+      allocate(alpha_lift(nq))
+      allocate(alpha_devil(nq))
+      allocate(dryness(ngridmx))
+      allocate(igcm_dustbin(nq))
+
 ! Initialization: get tracer names from the dynamics and check if we are
 !                 using 'old' tracer convention ('q01',q02',...)
@@ -60,5 +75,5 @@
       ! check if tracers have 'old' names
       count=0
-      do iq=1,nqmx
+      do iq=1,nq
         txt=" "
         write(txt,'(a1,i2.2)') 'q',iq
@@ -66,7 +81,7 @@
           count=count+1
         endif
-      enddo ! of do iq=1,nqmx
+      enddo ! of do iq=1,nq
       
-      if (count.eq.nqmx) then
+      if (count.eq.nq) then
         write(*,*) "initracer: tracers seem to follow old naming ",
      &             "convention (q01,q02,...)"
@@ -76,5 +91,5 @@
 
       ! copy tracer names from dynamics
-      do iq=1,nqmx
+      do iq=1,nq
         noms(iq)=tnom(iq)
       enddo
@@ -86,7 +101,6 @@
 ! Identify tracers by their names: (and set corresponding values of mmol)
       ! 0. initialize tracer indexes to zero:
-      do iq=1,nqmx
-        igcm_dustbin(iq)=0
-      enddo
+      igcm_dustbin(1:nq)=0
+
       igcm_dust_mass=0
       igcm_dust_number=0
@@ -130,5 +144,5 @@
       count=0
       if (dustbin.gt.0) then
-        do iq=1,nqmx
+        do iq=1,nq
           txt=" "
           write(txt,'(a4,i2.2)')'dust',count+1
@@ -138,8 +152,8 @@
             mmol(iq)=100.
           endif
-        enddo !do iq=1,nqmx
+        enddo !do iq=1,nq
       endif ! of if (dustbin.gt.0)
       if (doubleq) then
-        do iq=1,nqmx
+        do iq=1,nq
           if (noms(iq).eq."dust_mass") then
             igcm_dust_mass=iq
@@ -153,5 +167,5 @@
       endif ! of if (doubleq)
       if (microphys) then
-        do iq=1,nqmx
+        do iq=1,nq
           if (noms(iq).eq."ccn_mass") then
             igcm_ccn_mass=iq
@@ -165,5 +179,5 @@
       endif ! of if (microphys)
       if (submicron) then
-        do iq=1,nqmx
+        do iq=1,nq
           if (noms(iq).eq."dust_submicron") then
             igcm_dust_submicron=iq
@@ -174,5 +188,5 @@
       endif ! of if (submicron)
       ! 2. find chemistry and water tracers
-      do iq=1,nqmx
+      do iq=1,nq
         if (noms(iq).eq."co2") then
           igcm_co2=iq
@@ -337,10 +351,10 @@
         endif
 
-      enddo ! of do iq=1,nqmx
+      enddo ! of do iq=1,nq
       
       ! check that we identified all tracers:
-      if (count.ne.nqmx) then
+      if (count.ne.nq) then
         write(*,*) "initracer: found only ",count," tracers"
-        write(*,*) "               expected ",nqmx
+        write(*,*) "               expected ",nq
         do iq=1,count
           write(*,*)'      ',iq,' ',trim(noms(iq))
@@ -349,5 +363,5 @@
       else
         write(*,*) "initracer: found all expected tracers, namely:"
-        do iq=1,nqmx
+        do iq=1,nq
           write(*,*)'      ',iq,' ',trim(noms(iq))
         enddo
@@ -365,16 +379,16 @@
        ! as qsurf(i_h2o_vap) & as qsurf(i_h2o_ice), so to be clean:
        if (igcm_h2o_vap.ne.0) then
-         qsurf(1:ngridmx,igcm_h2o_vap)=0
+         qsurf(1:ngrid,igcm_h2o_vap)=0
        endif
       endif
 
 c------------------------------------------------------------
-c     Initialize tracers .... (in tracer.h)
+c     Initialize tracers .... (in tracer_mod)
 c------------------------------------------------------------
       ! start by setting everything to (default) zero
-      rho_q(1:nqmx)=0     ! tracer density (kg.m-3)
-      radius(1:nqmx)=0.   ! tracer particle radius (m)
-      alpha_lift(1:nqmx) =0.  ! tracer saltation vertical flux/horiz flux ratio (m-1)
-      alpha_devil(1:nqmx)=0.  ! tracer lifting coefficient by dust devils
+      rho_q(1:nq)=0     ! tracer density (kg.m-3)
+      radius(1:nq)=0.   ! tracer particle radius (m)
+      alpha_lift(1:nq) =0.  ! tracer saltation vertical flux/horiz flux ratio (m-1)
+      alpha_devil(1:nq)=0.  ! tracer lifting coefficient by dust devils
 
 
@@ -393,6 +407,6 @@
 c       iq=1: Q mass mixing ratio, iq=2: N number mixing ratio
 
-        if( (nqmx.lt.2).or.(water.and.(nqmx.lt.4)) ) then
-          write(*,*)'initracer: nqmx is too low : nqmx=', nqmx
+        if( (nq.lt.2).or.(water.and.(nq.lt.4)) ) then
+          write(*,*)'initracer: nq is too low : nq=', nq
           write(*,*)'water= ',water,' doubleq= ',doubleq   
         end if
@@ -499,11 +513,11 @@
          alpha_lift(igcm_h2o_vap) =0.
          alpha_devil(igcm_h2o_vap)=0.
-         if(water.and.(nqmx.ge.2)) then
+         if(water.and.(nq.ge.2)) then
            radius(igcm_h2o_ice)=3.e-6
            rho_q(igcm_h2o_ice)=rho_ice
            alpha_lift(igcm_h2o_ice) =0.
            alpha_devil(igcm_h2o_ice)=0.
-         elseif(water.and.(nqmx.lt.2)) then
-            write(*,*) 'nqmx is too low : nqmx=', nqmx
+         elseif(water.and.(nq.lt.2)) then
+            write(*,*) 'nq is too low : nq=', nq
             write(*,*) 'water= ',water
          endif
Index: /trunk/LMDZ.MARS/libf/phymars/newcondens.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/newcondens.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/newcondens.F	(revision 1036)
@@ -6,4 +6,5 @@
      $                  fluxsurf_sw,zls)
                                                    
+       use tracer_mod, only: noms
        IMPLICIT NONE
 c=======================================================================
@@ -61,5 +62,5 @@
 #include "paramet.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 
 c-----------------------------------------------------------------------
@@ -195,5 +196,5 @@
          if (tracer) then
 c          Prepare Special treatment if one of the tracer is CO2 gas
-           do iq=1,nqmx
+           do iq=1,nq
              if (noms(iq).eq."co2") then
                 ico2=iq
@@ -238,5 +239,5 @@
       END DO
          
-      DO iq=1,nqmx         
+      DO iq=1,nq
       DO l=1,nlayer
          DO ig=1,ngrid
@@ -531,5 +532,5 @@
              zu(l)   =pu(ig,l)   +pdu( ig,l)  *ptimestep
              zv(l)   =pv(ig,l)   +pdv( ig,l)  *ptimestep
-            do iq=1,nqmx
+            do iq=1,nq
              zq(l,iq)=pq(ig,l,iq)+pdq(ig,l,iq)*ptimestep
             enddo
@@ -564,5 +565,5 @@
             zum(1) = 0  
             zvm(1) = 0  
-            do iq=1,nqmx
+            do iq=1,nq
               zqm(1,iq)=0. ! most tracer do not condense !
             enddo
@@ -577,5 +578,5 @@
             call vl1d(zu ,2.,masse,w,zum) 
             call vl1d(zv ,2.,masse,w,zvm) 
-            do iq=1,nqmx
+            do iq=1,nq
              do l=1,nlayer
               zq1(l)=zq(l,iq)
@@ -602,5 +603,5 @@
             zum(nlayer+1)= zu(nlayer)  ! should not be used, but...
             zvm(nlayer+1)= zv(nlayer)  ! should not be used, but...
-            do iq=1,nqmx
+            do iq=1,nq
              zqm(nlayer+1,iq)= zq(nlayer,iq)
             enddo
@@ -637,5 +638,5 @@
 
 c           Tendencies on Q
-            do iq=1,nqmx
+            do iq=1,nq
 !              if (noms(iq).eq.'co2') then 
               if (iq.eq.ico2) then 
@@ -668,5 +669,5 @@
              if(pq(ig,1,ico2)+(pdq(ig,1,ico2)+pdqc(ig,1,ico2))*ptimestep
      &       .lt.qco2min) then 
-                do iq=1,nqmx
+                do iq=1,nq
                   zq(1,iq)=pq(ig,1,iq)
      &                     +(pdq(ig,1,iq)+pdqc(ig,1,iq))*ptimestep
@@ -675,5 +676,5 @@
                 Sm(1)  = masse(1)
                 do l =2,nlayermx
-                  do iq=1,nqmx
+                  do iq=1,nq
                      zq(l,iq)=pq(ig,l,iq)
      &                        +(pdq(ig,l,iq)+pdqc(ig,l,iq))*ptimestep
@@ -693,5 +694,5 @@
                  end do
  99              continue 
-                 do iq=1,nqmx
+                 do iq=1,nq
                    qmix=zq(nmix,iq) 
      &             +(Smq(nmix-1,iq)-zq(nmix,iq)*Sm(nmix-1))/mixmas
Index: /trunk/LMDZ.MARS/libf/phymars/nirco2abs.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/nirco2abs.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/nirco2abs.F	(revision 1036)
@@ -2,4 +2,5 @@
      $     mu0,fract,declin,pdtnirco2)
                                                    
+       use tracer_mod, only: igcm_co2, igcm_o
        IMPLICIT NONE
 c=======================================================================
@@ -50,5 +51,5 @@
 #include "comdiurn.h"
 #include "nirdata.h"
-#include "tracer.h"
+!#include "tracer.h"
 
 c-----------------------------------------------------------------------
Index: /trunk/LMDZ.MARS/libf/phymars/nltecool.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/nltecool.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/nltecool.F	(revision 1036)
@@ -30,4 +30,5 @@
 c***************************************************************************
 
+      use tracer_mod, only: igcm_co2, igcm_co, igcm_o, igcm_n2, mmol
       implicit none
 
@@ -37,5 +38,5 @@
 #include "chimiedata.h"
 #include "conc.h" !Added to have "dynamic composition" in the scheme
-#include "tracer.h" !"
+!#include "tracer.h" !"
 #include "callkeys.h"
 
Index: /trunk/LMDZ.MARS/libf/phymars/nuclea.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/nuclea.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/nuclea.F	(revision 1036)
@@ -17,5 +17,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "microphys.h"
 
Index: /trunk/LMDZ.MARS/libf/phymars/phyetat0.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/phyetat0.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/phyetat0.F	(revision 1036)
@@ -4,4 +4,5 @@
 
       use netcdf
+      use infotrac, only: nqtot, tnom
 
       implicit none
@@ -25,5 +26,5 @@
 #include "comcstfi.h"
 !#include "tracer.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 #include "control.h"
 c======================================================================
@@ -96,5 +97,5 @@
 !                    qsurf02, ...)
       count=0
-      do iq=1,nqmx
+      do iq=1,nqtot
         txt= " "
         write(txt,'(a5,i2.2)')'qsurf',iq
@@ -108,5 +109,5 @@
         endif
       enddo
-      if (count.eq.nqmx) then
+      if (count.eq.nqtot) then
         write(*,*) "phyetat0:tracers seem to follow old naming ",
      &             "convention (qsurf01,qsurf02,...)"
@@ -650,9 +651,9 @@
 c        case when new tracer are added in addition to old ones
              write(*,*)'qsurf 1 to ', nqold,'were already present'
-             write(*,*)'qsurf ', nqold+1,' to ', nqmx,'are new'
+             write(*,*)'qsurf ', nqold+1,' to ', nqtot,'are new'
 !            yes=' '
 !            do while ((yes.ne.'y').and.(yes.ne.'n'))
 !             write(*,*) 'Would you like to reindex qsurf # 1 ->',nqold
-!             write(*,*) 'to #',nqmx-nqold+1,'->', nqmx,'   (y or n) ?'
+!             write(*,*) 'to #',nqtot-nqold+1,'->', nqtot,'   (y or n) ?'
 !             read(*,fmt='(a)') yes
 !            end do
@@ -660,8 +661,8 @@
 !              write(*,*) 'OK, let s reindex qsurf'
 !                 do ig=1,ngridmx
-!                    do iq=nqmx,nqmx-nqold+1,-1
-!                       qsurf(ig,iq)=qsurf(ig,iq-nqmx+nqold)
+!                    do iq=nqtot,nqtot-nqold+1,-1
+!                       qsurf(ig,iq)=qsurf(ig,iq-nqtot+nqold)
 !                    end do
-!                    do iq=nqmx-nqold,1,-1
+!                    do iq=nqtot-nqold,1,-1
 !                       qsurf(ig,iq)= 0.
 !                    end do
Index: /trunk/LMDZ.MARS/libf/phymars/physdem.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/physdem.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/physdem.F	(revision 1036)
@@ -3,4 +3,5 @@
      .                   alb,ith,pzmea,pzstd,pzsig,pzgam,pzthe)
 
+      use infotrac, only: nqtot, tnom
       implicit none
 c
@@ -32,5 +33,5 @@
 #include "netcdf.inc"
 #include "dimphys.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 #include "callkeys.h"
 c
@@ -585,5 +586,5 @@
 !                    qsurf02, ...)
       count=0
-      do iq=1,nqmx
+      do iq=1,nqtot
         txt= " "
         write(txt,'(a1,i2.2)')'q',iq
@@ -596,5 +597,5 @@
         endif
       enddo
-      if (count.eq.nqmx) then
+      if (count.eq.nqtot) then
         write(*,*) "physdem0:tracers seem to follow old naming ",
      &             "convention (qsurf01,qsurf02,...)"
@@ -602,5 +603,5 @@
         write(*,*) "     but you should run newstart to rename them"
         oldtracernames=.true.
-      endif ! of if (count.eq.nqmx)
+      endif ! of if (count.eq.nqtot)
 
       IF(nq.GE.1) THEN
@@ -693,4 +694,5 @@
      .                   phystep,time,
      .                   tsurf,tsoil,co2ice,emis,q2,qsurf)
+      use infotrac, only: nqtot, tnom
       implicit none
 c
@@ -720,5 +722,5 @@
 #include "netcdf.inc"
 #include "dimphys.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 #include "callkeys.h"
 c
@@ -918,5 +920,5 @@
       IF (firstcall) THEN
         count=0
-        do iq=1,nqmx
+        do iq=1,nqtot
           txt= " "
           write(txt,'(a1,i2.2)')'q',iq
@@ -929,5 +931,5 @@
           endif
         enddo
-        if (count.eq.nqmx) then
+        if (count.eq.nqtot) then
           write(*,*) "physdem1:tracers seem to follow old naming ",
      &               "convention (qsurf01,qsurf02,...)"
@@ -935,13 +937,13 @@
           write(*,*) "     but you should run newstart to rename them"
           oldtracernames=.true.
-        endif ! of if (count.eq.nqmx)
+        endif ! of if (count.eq.nqtot)
       ENDIF ! of if(firstcall)
       
       ! If computing water cycle with ice, move surface ice
-      ! back to qsurf(nqmx)
+      ! back to qsurf(nqtot)
       IF (oldtracernames .and. water) THEN
        !"loop" to avoid potential out-of-bounds on arrays
-        write(*,*)'physdem1: moving surface water ice to index ',nqmx
-        do iq=nqmx,nqmx
+        write(*,*)'physdem1: moving surface water ice to index ',nqtot
+        do iq=nqtot,nqtot
           qsurf(1:ngridmx,iq)=qsurf(1:ngridmx,iq-1)
           qsurf(1:ngridmx,iq-1)=0
Index: /trunk/LMDZ.MARS/libf/phymars/physiq.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 1036)
@@ -12,5 +12,13 @@
      $            )
 
-
+      use tracer_mod, only: noms, mmol, igcm_co2, igcm_n2,
+     &                      igcm_co, igcm_o, igcm_h2o_vap, igcm_h2o_ice,
+     &                      igcm_ccn_mass, igcm_ccn_number,
+     &                      igcm_dust_mass, igcm_dust_number, igcm_h2o2,
+     &                      nuice_ref, rho_ice, rho_dust, ref_r0
+
+#ifdef MESOSCALE
+      use infotrac !!! this is necessary for tracers 
+#endif
       IMPLICIT NONE
 c=======================================================================
@@ -103,5 +111,5 @@
 c    pdv(ngrid,nlayermx)       |  Temporal derivative of the corresponding
 c    pdt(ngrid,nlayermx)       |  variables due to physical processes.
-c    pdq(ngrid,nlayermx,nqmx)  |
+c    pdq(ngrid,nlayermx,nq)    |
 c    pdpsrf(ngrid)             |
 c    tracerdyn                 call tracer in dynamical part of GCM ?
@@ -126,5 +134,5 @@
 #include "dimradmars.h"
 #include "comg1d.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "nlteparams.h"
 #include "comvert.h"
@@ -142,5 +150,5 @@
 #include "wrf_output_2d.h"
 #include "wrf_output_3d.h"
-#include "advtrac.h"   !!! this is necessary for tracers (in dyn3d)
+!#include "advtrac.h"   !!! this is necessary for tracers (in dyn3d)
 #include "meso_inc/meso_inc_var.F"
 #endif
@@ -192,5 +200,5 @@
       REAL capcal(ngridmx)           ! surface heat capacity (J m-2 K-1)
       REAL fluxgrd(ngridmx)          ! surface conduction flux (W.m-2)
-      REAL qsurf(ngridmx,nqmx)       ! tracer on surface (e.g. kg.m-2)
+      REAL,ALLOCATABLE,SAVE :: qsurf(:,:) ! tracer on surface (e.g. kg.m-2)
       REAL q2(ngridmx,nlayermx+1)    ! Turbulent Kinetic Energy
       
@@ -217,5 +225,5 @@
       SAVE aerosol, tsurf,tsoil
       SAVE co2ice,albedo,emis, q2
-      SAVE capcal,fluxgrd,dtrad,fluxrad,fluxrad_sky,qsurf
+      SAVE capcal,fluxgrd,dtrad,fluxrad,fluxrad_sky
 
       REAL stephan   
@@ -229,6 +237,6 @@
       EXTERNAL CBRT
 
-      CHARACTER*80 fichier 
-      INTEGER l,ig,ierr,igout,iq,i, tapphys
+!      CHARACTER*80 fichier 
+      INTEGER l,ig,ierr,igout,iq,tapphys
 
       REAL fluxsurf_lw(ngridmx)      !incident LW (IR) surface flux (W.m-2)
@@ -243,12 +251,12 @@
       REAL zzlay(ngridmx,nlayermx)   ! altitude at the middle of the layers
       REAL zzlev(ngridmx,nlayermx+1) ! altitude at layer boundaries
-      REAL latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
+!      REAL latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
 
 c     Tendancies due to various processes:
-      REAL dqsurf(ngridmx,nqmx)
+      REAL dqsurf(ngridmx,nq)
       REAL zdtlw(ngridmx,nlayermx)     ! (K/s)
       REAL zdtsw(ngridmx,nlayermx)     ! (K/s)
-      REAL cldtlw(ngridmx,nlayermx)     ! (K/s) LW heating rate for clear area
-      REAL cldtsw(ngridmx,nlayermx)     ! (K/s) SW heating rate for clear area
+!      REAL cldtlw(ngridmx,nlayermx)     ! (K/s) LW heating rate for clear area
+!      REAL cldtsw(ngridmx,nlayermx)     ! (K/s) SW heating rate for clear area
       REAL zdtnirco2(ngridmx,nlayermx) ! (K/s)
       REAL zdtnlte(ngridmx,nlayermx)   ! (K/s)
@@ -264,13 +272,13 @@
       REAL zdvc(ngridmx,nlayermx),zduc(ngridmx,nlayermx)
 
-      REAL zdqdif(ngridmx,nlayermx,nqmx), zdqsdif(ngridmx,nqmx)
-      REAL zdqsed(ngridmx,nlayermx,nqmx), zdqssed(ngridmx,nqmx)
-      REAL zdqdev(ngridmx,nlayermx,nqmx), zdqsdev(ngridmx,nqmx)
-      REAL zdqadj(ngridmx,nlayermx,nqmx)
-      REAL zdqc(ngridmx,nlayermx,nqmx)
-      REAL zdqcloud(ngridmx,nlayermx,nqmx)
-      REAL zdqscloud(ngridmx,nqmx)
-      REAL zdqchim(ngridmx,nlayermx,nqmx)
-      REAL zdqschim(ngridmx,nqmx)
+      REAL zdqdif(ngridmx,nlayermx,nq), zdqsdif(ngridmx,nq)
+      REAL zdqsed(ngridmx,nlayermx,nq), zdqssed(ngridmx,nq)
+      REAL zdqdev(ngridmx,nlayermx,nq), zdqsdev(ngridmx,nq)
+      REAL zdqadj(ngridmx,nlayermx,nq)
+      REAL zdqc(ngridmx,nlayermx,nq)
+      REAL zdqcloud(ngridmx,nlayermx,nq)
+      REAL zdqscloud(ngridmx,nq)
+      REAL zdqchim(ngridmx,nlayermx,nq)
+      REAL zdqschim(ngridmx,nq)
 
       REAL zdteuv(ngridmx,nlayermx)    ! (K/s)
@@ -278,5 +286,5 @@
       REAL zdumolvis(ngridmx,nlayermx)
       REAL zdvmolvis(ngridmx,nlayermx)
-      real zdqmoldiff(ngridmx,nlayermx,nqmx)
+      real zdqmoldiff(ngridmx,nlayermx,nq)
 
 c     Local variable for local intermediate calcul:
@@ -295,8 +303,8 @@
       REAL ps(ngridmx), zt(ngridmx,nlayermx)
       REAL zu(ngridmx,nlayermx),zv(ngridmx,nlayermx)
-      REAL zq(ngridmx,nlayermx,nqmx)
+      REAL zq(ngridmx,nlayermx,nq)
       REAL fluxtop_sw_tot(ngridmx), fluxsurf_sw_tot(ngridmx)
       character*2 str2
-      character*5 str5
+!      character*5 str5
       real zdtdif(ngridmx,nlayermx), zdtadj(ngridmx,nlayermx)
       REAL tauscaling(ngridmx)   ! Convertion factor for qdust and Ndust
@@ -310,10 +318,10 @@
       ! instead, use zplay and zplev :
       REAL zplev(ngrid,nlayermx+1),zplay(ngrid,nlayermx) 
-      REAL zstress(ngrid), cd
-      real hco2(nqmx),tmean, zlocal(nlayermx)
+!      REAL zstress(ngrid),cd
+      real tmean, zlocal(nlayermx)
       real rho(ngridmx,nlayermx)  ! density
       real vmr(ngridmx,nlayermx)  ! volume mixing ratio
       real rhopart(ngridmx,nlayermx) ! number density of a given species
-      real colden(ngridmx,nqmx)   ! vertical column of tracers
+      real colden(ngridmx,nq)     ! vertical column of tracers
       REAL mtot(ngridmx)          ! Total mass of water vapor (kg/m2)
       REAL icetot(ngridmx)        ! Total mass of water ice (kg/m2)
@@ -357,5 +365,5 @@
       REAL, SAVE :: hfmax_th(ngridmx)
       REAL pdu_th(ngridmx,nlayermx),pdv_th(ngridmx,nlayermx)
-      REAL pdt_th(ngridmx,nlayermx),pdq_th(ngridmx,nlayermx,nqmx)
+      REAL pdt_th(ngridmx,nlayermx),pdq_th(ngridmx,nlayermx,nq)
       INTEGER lmax_th(ngridmx),dimout,n_out,n
       CHARACTER(50) zstring
@@ -364,9 +372,11 @@
       REAL, ALLOCATABLE, DIMENSION(:,:) :: T_out
       REAL, ALLOCATABLE, DIMENSION(:,:) :: u_out ! Interpolated teta and u at z_out
-      REAL u_out1(ngridmx), T_out1(ngridmx)
+!      REAL u_out1(ngridmx)
+      REAL T_out1(ngridmx)
       REAL, ALLOCATABLE, DIMENSION(:) :: z_out     ! height of interpolation between z0 and z1 [meters]
       REAL ustar(ngridmx),tstar(ngridmx)  ! friction velocity and friction potential temp
       REAL L_mo(ngridmx),vhf(ngridmx),vvv(ngridmx)
-      REAL zu2(ngridmx),sensibFlux(ngridmx)
+!      REAL zu2(ngridmx)
+      REAL sensibFlux(ngridmx)
 
 c=======================================================================
@@ -379,4 +389,7 @@
       IF (firstcall) THEN
 
+        ! allocate local (saved) arrays:
+        allocate(qsurf(ngrid,nq))
+        
 c        variables set to 0
 c        ~~~~~~~~~~~~~~~~~~
@@ -417,5 +430,5 @@
          tracerdyn=tracer
          IF (tracer) THEN
-            CALL initracer(qsurf,co2ice)
+            CALL initracer(ngrid,nq,qsurf,co2ice)
          ENDIF  ! end tracer
 
@@ -570,5 +583,5 @@
 
       if(photochem.or.callthermos) then
-         call concentrations(zplay,pt,pdt,pq,pdq,ptimestep)
+         call concentrations(nq,zplay,pt,pdt,pq,pdq,ptimestep)
       endif
 #endif
@@ -1214,5 +1227,6 @@
      $                       surfdust, surfice)
 !           call photochemistry
-            call calchim(ptimestep,zplay,zplev,pt,pdt,dist_sol,mu0,
+            call calchim(nq,
+     &                   ptimestep,zplay,zplev,pt,pdt,dist_sol,mu0,
      $                   zzlev,zzlay,zday,pq,pdq,zdqchim,zdqschim,
      $                   zdqcloud,zdqscloud,tauref,co2ice,
Index: /trunk/LMDZ.MARS/libf/phymars/simpleclouds.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/simpleclouds.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/simpleclouds.F	(revision 1036)
@@ -4,4 +4,5 @@
      &             nq,tau,rice)
       USE updaterad
+      use tracer_mod, only: igcm_h2o_vap, igcm_h2o_ice
       implicit none
 c------------------------------------------------------------------
@@ -32,5 +33,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comgeomfi.h"
 #include "dimradmars.h"
@@ -73,6 +74,6 @@
       INTEGER ig,l
 
-      REAL zq(ngridmx,nlayermx,nqmx)  ! local value of tracers
-      REAL zq0(ngridmx,nlayermx,nqmx) ! local initial value of tracers
+      REAL zq(ngridmx,nlayermx,nq)    ! local value of tracers
+      REAL zq0(ngridmx,nlayermx,nq)   ! local initial value of tracers
       REAL zt(ngridmx,nlayermx)       ! local value of temperature
       REAL zqsat(ngridmx,nlayermx)    ! saturation
@@ -91,5 +92,5 @@
 c    -----------------
 
-c    On "update" la valeur de q(nqmx) (water vapor) et temperature.
+c    On "update" la valeur de q(nq) (water vapor) et temperature.
 c    On effectue qqes calculs preliminaires sur les couches : 
 
Index: /trunk/LMDZ.MARS/libf/phymars/soil_tifeedback.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/soil_tifeedback.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/soil_tifeedback.F	(revision 1036)
@@ -1,3 +1,5 @@
       SUBROUTINE soil_tifeedback(ngrid,nsoil,icecover,newtherm_i)
+
+      use tracer_mod, only: nqmx, igcm_h2o_ice, rho_ice
       IMPLICIT NONE
 
@@ -24,5 +26,5 @@
 #include "dimphys.h"
 #include "comsoil.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "surfdat.h"
 
@@ -41,5 +43,5 @@
 
       REAL icecover(ngrid,nqmx)         ! tracer on the surface (kg.m-2)
-                                        ! last one (iq=nqmx) is surface
+                                        ! (iq=igcm_h2o_ice) is surface
                                         ! water ice
 c Outputs
Index: /trunk/LMDZ.MARS/libf/phymars/surfini.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/surfini.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/phymars/surfini.F	(revision 1036)
@@ -3,4 +3,5 @@
       USE ioipsl_getincom
       use netcdf
+      use tracer_mod, only: nqmx, noms, dryness
       IMPLICIT NONE
 c=======================================================================
@@ -16,5 +17,5 @@
 #include "surfdat.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comgeomfi.h"
 #include "comcstfi.h"
